Add LoadPath projectPath.


Require Import propositional_formulas.
Require Import propositional_formulas_semantics.
Require Import Bool.

(*----------propForm cons----------*)

Definition propForm_cons (f g:propForm):Prop := 
  forall theta:environment, [[f]]theta -> [[g]]theta.

Definition propForm_eqv (f g:propForm):Prop :=
  forall theta:environment, [[f]] theta <-> [[g]] theta.

Lemma full_false_eqv_bot : forall f:propForm, ~[[f]]full_environment -> propForm_eqv f bot.
Proof.
intros;split;intro;simpl in *.
induction f;simpl in *;auto.
apply orb_true_iff in H0.
destruct H0.
apply IHf1;auto.
intro.
apply H.
apply orb_true_iff;auto.
apply IHf2;auto.
intro.
apply H.
apply orb_true_iff;auto.
apply andb_true_iff in H0.
destruct H0.
assert ([[f1]]full_environment \/ [[f2]]full_environment).
  destruct ([[f1]]full_environment);auto.
destruct H2.
apply IHf2;auto.
intro;apply H;apply andb_true_iff;split;auto.
apply IHf1;auto.
intro;apply H;apply andb_true_iff;split;auto.
inversion H0.
Qed.

Lemma empty_true_eqv_top : forall f:propForm, [[f]]empty_environment -> propForm_eqv f top.
Proof.
intros;split;intro;simpl in *;auto.
induction f;simpl in *;auto.
inversion H.
apply orb_true_iff in H;destruct H;apply orb_true_iff.
left;apply IHf1;auto.
right;apply IHf2;auto.
apply andb_true_iff in H;apply andb_true_iff;destruct H;split.
apply IHf1;auto.
apply IHf2;auto.
Qed.

Lemma var_cons_var_eq : forall x y:propVar, 
  propForm_cons (var x) (var y) -> x=y.
Proof.
intros.
specialize (H (environment_point x)).
simpl in *.
assert (environment_point x x).
  unfold environment_point.
  rewrite<- EqNat.beq_nat_refl;auto.
specialize (H H0);unfold environment_point in H.
apply EqNat.beq_nat_true;auto.
Qed.

Lemma var_cons : forall x:propVar, forall f:propForm,
  [[f]](environment_point x) -> propForm_cons (var x) f.
Proof.
intros;induction f;intro;intros;simpl in *;auto.
unfold environment_point in H.
rewrite<- (EqNat.beq_nat_true _ _ H);auto.

apply orb_true_iff;apply orb_true_iff in H;destruct H.
left;apply IHf1;auto.
right;apply IHf2;auto.

apply andb_true_iff;apply andb_true_iff in H;destruct H;split.
apply IHf1;auto.
apply IHf2;auto.
Qed.

Lemma propForm_min_env : forall f:propForm, ~propForm_eqv f bot -> [[f]]min_environment f.
Proof.
induction f;intros;auto.
exfalso;apply H;split;auto.
unfold min_environment.
simpl.
rewrite<- EqNat.beq_nat_refl;auto.

destruct (propForm_solution_choice f1 full_environment).
assert (~propForm_eqv f1 bot).
  intro.
  assert (false).
    apply (H1 full_environment);auto.
  inversion H2.

simpl;apply orb_true_iff.
left;apply environment_union_maintains.
apply IHf1;auto.
assert (~propForm_eqv f2 bot).
  intro.
  apply H.
  apply full_false_eqv_bot.
  intro.
  simpl in H2;apply orb_true_iff in H2;destruct H2;auto.
  assert ([[bot]]full_environment).
    apply H1;auto.
  inversion H3.
simpl;apply orb_true_iff.
right;apply environment_union_commutes;apply environment_union_maintains.
apply IHf2;auto.

assert (~propForm_eqv f1 bot).
  intro.
  apply H.
  split;intro;auto.
  apply H0.
  apply andb_true_iff in H1;destruct H1;auto.
  inversion H1.
assert (~propForm_eqv f2 bot).
  intro.
  apply H.
  split;intro;auto.
  apply H1.
  apply andb_true_iff in H2;destruct H2;auto.
  inversion H2.

apply andb_true_iff;split.
apply environment_union_maintains.
apply IHf1;auto.
apply environment_union_commutes;apply environment_union_maintains.
apply IHf2;auto.
Qed.