Add LoadPath projectPath.

Require Import relation_definitions.
Require Import relation_lemmas.
Require Import relative_consequence.
Require Import relative_consequence_excluded_middle.
Require Import relation_induction_on_unrelated.
Require Import BES.
Require Import relations_on_BES.
Require Import consistent_consequence.
Require Import relative_consistent_consequence.
Require Import Bool.
Require Import Ensembles.
Require Import Finite_sets.


Lemma rel_cc_dec_n_bnd : forall n:_, forall E:_, w_d E -> forall G:_, rev_subset_card _ (rel_all_bnd_eq_rank E) G n ->
  ens_dec _ (rel_cc_max E G).
Proof.
induction n;intros E w_d_E G H.
assert (0=0);auto.
rewrite<- (Extensionality_Ensembles _ _ _ (rev_subset_card0 _ _ _ _ H H0)).
rewrite (Extensionality_Ensembles _ _ _ (rel_cc_max_rel_all_eq_rank_bnd E)).
apply rel_all_eq_rank_bnd_dec.

assert (Finite _ G).
  apply (rev_subset_finite _ (eq_dec_pairs _ eq_dec_nat) _ _ (rev_subset_card_rev_subset _ _ _ _ H) (rel_all_eq_rank_bnd_finite _ w_d_E)).
rename H0 into fin_G.
intro;intros.
assert (G x \/ ~G x).
  apply (Finite_dec _ (eq_dec_pairs _ eq_dec_nat));auto.
destruct H0.
  left.
  exists (Empty_set _).
  split.
  intro;intros;inversion H1.
  split.
  intro;intros;inversion H1.
  split.
  intro;intros;inversion H1.
  apply Union_intror;auto.
destruct (rel_all_eq_rank_bnd_dec E x).
assert (rev_subset_card _ (rel_all_bnd_eq_rank E) (Add _ G x) n).
  assert (Same_set _ G (Subtract _ (Add _ G x) x)).
    split;intro;intros.
    split;auto.
    left;auto.
    intro.
    assert (x = x0).
      elim H3;auto.
    rewrite H4 in *;auto.
    destruct H2;auto.
    destruct H2;auto.
    contradiction.
  rewrite (Extensionality_Ensembles _ _ _ H2) in H.
  assert (~In _ (Subtract _ (Add _ G x) x) x).
    intro.
    destruct H3;apply H4;apply In_singleton.
  specialize (rev_subset_card_minus _ (eq_dec_pairs _ eq_dec_nat) _ _ (rel_all_eq_rank_bnd_finite _ w_d_E) _ H _ H1 H3).
  intro.
  simpl in *.
  assert (n-0=n).
    destruct n;auto.
  rewrite H5 in H4.
  assert (Same_set _ (Add _ G x) (Add (nat * nat) (Subtract (nat * nat) (Add (nat * nat) G x) x) x)).
    split;intro;intros.
    destruct (eq_dec_pairs _ eq_dec_nat x x0).
    rewrite e in *.
    right;split;auto.
    destruct H6.
    left;split.
    left;auto.
    intro;apply n0;elim H7;auto.
    exfalso;apply n0;elim H6;auto.
    destruct H6.
    destruct H6;auto.
    right;auto.
  rewrite (Extensionality_Ensembles _ _ _ H6);auto.
destruct (IHn _ w_d_E _ H2 x).
assert (rel_cons (rel_cc_max E (Add _ G x)) (rhs E (fst x)) (rhs E (snd x)) \/ ~rel_cons (rel_cc_max E (Add _ G x)) (rhs E (fst x)) (rhs E (snd x))).
  assert (Included (nat * nat) (rel_cc_max E (Add (nat * nat) G x)) (rel_all_bnd_eq_rank E)).
    intro;intros.
    destruct H4 as [R H4].
    destruct H4.
    destruct H5.
    destruct H6.
    destruct H7.
    split.
    apply (H4 _ H7).
    apply (H5 _ H7).
    apply (rev_subset_contains _ _ _ (rev_subset_card_rev_subset _ _ _ _ H2));auto.
  destruct (rel_cons_dec _ (subset_finite_eq_rel _ (eq_dec_pairs _ eq_dec_nat) _ (rel_all_eq_rank_bnd_finite _ w_d_E) (rel_cc_max E (Add (nat * nat) G x))
      (IHn _ w_d_E _ H2) H4) (rhs E (fst x)) (rhs E (snd x)));auto.
  destruct H5 as [theta H5].
  destruct H5.
  destruct H6.
  right;intro;apply H7.
  apply H8;auto.
rename H4 into H6.
destruct H1.
destruct H4.
destruct H6.
left.
exists (Add _ (Setminus _ (rel_cc_max E (Add _ G x)) G) x).
split.
intro;intros.
destruct (eq_dec_pairs _ eq_dec_nat x XY).
rewrite e in *;auto.
destruct H7.
destruct H7.
destruct H7 as [R H7].
destruct H7.
destruct H9.
destruct H10.
destruct H11.
destruct (H7 x0);auto.
destruct H11;try contradiction.
exfalso;apply n0;elim H11;auto.
exfalso;apply n0;elim H7;auto.
split.
intro;intros.
destruct (eq_dec_pairs _ eq_dec_nat x XY).
rewrite e in *;auto.
destruct H7.
destruct H7.
destruct H7 as [R H7].
destruct H7.
destruct H9.
destruct H10.
destruct H11.
destruct (H7 x0);auto.
destruct H11;try contradiction.
exfalso;apply n0;elim H11;auto.
exfalso;apply n0;elim H7;auto.
split.
intro;intros.
destruct (eq_dec_pairs _ eq_dec_nat x XY).
rewrite e in *.
intro;intros.
destruct (consistent_environment_rel_union _ _ _ H8).
apply H6;auto.
intro;intros.
destruct (eq_dec_pairs _ eq_dec_nat XY (x0,y)).
destruct XY as (x1,y1).
assert (x1=x0).
  congruence.
assert (y1=y).
  congruence.
rewrite H14 in *.
rewrite H15 in *.
apply (H10 x0);auto.
assert (G (x0,y) \/ ~G (x0,y)).
  apply (Finite_dec _ (eq_dec_pairs _ eq_dec_nat));auto.
destruct H14.
apply (H11 x0);auto.
apply (H10 x0);auto.
left.
split;auto.
destruct H7.
destruct H7.
intro;intros.
destruct (consistent_environment_rel_union _ _ _ H9).
destruct H7 as [R H7].
destruct H7.
destruct H13.
destruct H14.
apply (H14 x0);auto.
destruct H15;auto.
exfalso.
destruct H15;auto.
apply n0;elim H15;auto.
intro;intros.
assert (G (x1,y) \/ ~(G (x1,y))).
  apply (Finite_dec _ (eq_dec_pairs _ eq_dec_nat));auto.
destruct H18.
apply (H12 x1);auto.
destruct (eq_dec_pairs _ eq_dec_nat x (x1,y)).
rewrite e in *.
apply (H11 x1);auto.
left;split;auto.
apply (H11 x1);auto.
left;split;auto.
exists R;auto.
exfalso.
apply n0;elim H7;auto.
apply Union_introl.
right.
apply In_singleton.

right;intro.
apply H6.
intro;intros.
assert (consistent_environment theta (rel_cc_max E G)).
  intro;intros.
  apply (H8 x0);auto.
  clear - H10.
  destruct H10 as [R H].
  exists R.
  destruct H.
  destruct H0.
  destruct H1.
  split;auto.
  split;auto.
  split.
  intro;intros;intro;intros.
  apply (H1 XY);auto.
  intro;intros.
  apply (H4 x1);auto.
  remember (x1,y0) as xy.
  destruct H6.
  apply Union_introl;auto.
  apply Union_intror;left;auto.
  remember (x0,y) as xy.
  destruct H2.
  apply Union_introl;auto.
  apply Union_intror;left;auto.
destruct (cc_rel_max_cons_env_has_cc _ _ _ H10 _ H7) as [R H11].
destruct H11.
destruct H11.
destruct H12.
destruct H12;try contradiction.
apply (H13 x);auto.
exfalso.
apply H3.
exists (Empty_set _).
split.
intro;intros;inversion H4.
split.
intro;intros;inversion H4.
split.
intro;intros;inversion H4.
apply Union_intror;right;apply In_singleton;auto.
right;intro.
destruct H2 as [R H2].
destruct H2.
destruct H3.
destruct H4.
destruct H5;auto.
apply H1.
split.
apply H2;auto.
apply H3;auto.
Qed.

Lemma rel_cc_dec_bnd : forall E:_, w_d E -> forall G:_, rev_subset _ (rel_all_bnd_eq_rank E) G -> ens_dec _ (rel_cc_max E G).
Proof.
intros;intro;intros.
destruct (exists_rev_subset _ _ _ H0) as [n H1].
apply (rel_cc_dec_n_bnd _ _ H _ H1 x);auto.
Qed.

Lemma cc_dec : forall E:_, w_d E -> ens_dec _ (cc_max E).
Proof.
intros;rewrite (eq_cc_max_rel_cc_max E).
apply rel_cc_dec_bnd;auto.
apply empty_rev_subset.
apply (eq_dec_pairs _ eq_dec_nat).
apply rel_all_eq_rank_bnd_finite;auto.
Qed.

Lemma rel_cc_max_finite : forall E:_, w_d E -> forall G:_, rev_subset _ (rel_all_bnd_eq_rank E) G ->
  Finite _ (rel_cc_max E G).
Proof.
intros.
apply (subset_finite_eq_rel _ (eq_dec_pairs _ eq_dec_nat) _ (rel_all_eq_rank_bnd_finite _ H) (rel_cc_max E G)).
apply rel_cc_dec_bnd;auto.
intro;intros.
destruct H1.
destruct H1.
destruct H2.
destruct H3.
destruct H4.
split.
apply H1;auto.
apply H2;auto.

apply (rev_subset_contains _ _ _ H0);auto.
Qed.

Lemma Setminus_finite : forall A:_, eq_dec A -> forall r1 r2:_, Finite A r1 -> Finite _ r2 -> Finite _ (Setminus _ r1 r2).
Proof.
intros.
induction H0.
rewrite (Extensionality_Ensembles _ (Setminus A r1 (Empty_set A)) r1);auto.
split;intro;intros.
destruct H0;auto.
split;auto.
intro;inversion H1.

rewrite (Extensionality_Ensembles _ (Setminus A r1 (Add A A0 x)) (Subtract _ (Setminus A r1 A0) x));auto.
apply rem_is_Finite;auto.
split;intro;intros.
destruct H2.
split.
split;auto.
intro;apply H3;left;auto.
intro;apply H3;right;auto.
destruct H2.
destruct H2.
split;auto.
intro.
destruct H5;auto.
Qed.

Lemma rel_cc_exists_finite : forall E:_, w_d E -> forall G:_, rev_subset _ (rel_all_bnd_eq_rank E) G ->
  forall XY:_, rel_cc_max E G XY -> exists R:_, Finite _ R /\ (Union _ R G) XY /\ relative_cc E R G /\ relates_bound E R.
Proof.
intros.
exists (Setminus _ (rel_cc_max E G) G).
split.
apply Setminus_finite.
apply (eq_dec_pairs _ eq_dec_nat).
apply rel_cc_max_finite;auto.
apply (rev_subset_finite _ (eq_dec_pairs _ eq_dec_nat) _ _ H0).
apply rel_all_eq_rank_bnd_finite;auto.
split.
destruct (Finite_dec _ (eq_dec_pairs _ eq_dec_nat) _ (rev_subset_finite _ (eq_dec_pairs _ eq_dec_nat) _ _ H0 (rel_all_eq_rank_bnd_finite _ H)) XY).
apply Union_intror;auto.
apply Union_introl.
split;auto.
split.
split.
intro;intros.
destruct H2.
destruct H2.
destruct H2.
apply H2.
destruct H4.
destruct H5.
destruct H6;auto;contradiction.
intro;intros.
destruct H2.
destruct H2.
destruct H2.
destruct H4.
destruct H5.
destruct H6;try contradiction.
intro;intros.
apply H5;auto.
intro;intros.
apply (H7 x1);auto.
destruct (Finite_dec _ (eq_dec_pairs _ eq_dec_nat) _ (rev_subset_finite _ (eq_dec_pairs _ eq_dec_nat) _ _ H0 (rel_all_eq_rank_bnd_finite _ H)) (x1,y)).
apply Union_intror;auto.
apply Union_introl.
split;auto.
exists x;auto.

intro;intros.
destruct H2.
destruct H2.
destruct H2.
destruct H4;apply H4;auto.
destruct H5.
destruct H6;auto;contradiction.
Qed.











