Add LoadPath projectPath.

Require Import relation_definitions.
Require Import propositional_formulas.
Require Import propositional_formulas_semantics.
Require Import consequence_propositional_formula.
Require Import propositional_formula_DNF.
Require Import propositional_formula_consequence_ex_mid.
Require Import proofSystem_consistent_consequence.
Require Import Bool.
Require Import Arith.

(*proof system is complete for (f/\g) => (distribute f g)*)

Lemma distribute_prv_tree : forall E:_, forall G:relation propVar, forall g:propForm, 
  DNF_propForm g -> forall f:propForm, DNF_propForm f -> prv_tree E (stmt G (f /\p g) (distribute f g)).
Proof.
intros E G g H.
induction H using DNF_ind;intros.
apply (TRA _ _ (top /\p f)).
apply COM1.
induction H using DNF_ind;simpl in *.
  apply REF.
  apply COM1.
  apply COM1.
  apply COM1.
  apply (TRA _ _ ((top /\p f) \/p (top /\p g))).
  apply DS3.
  apply aSPLIT.
  apply cGROW_L;auto.
  apply cGROW_R;auto.

apply (TRA _ _ (bot /\p f)).
apply COM1.
induction H using DNF_ind;simpl.
  apply COM1.
  apply REF.
  apply COM1.
  apply COM1.
  apply (TRA _ _ ((bot /\p f) \/p (bot /\p g))).
  apply DS3.
  apply aSPLIT.
  apply cGROW_L;auto.
  apply cGROW_R;auto.

apply (TRA _ _ (var x /\p f)).
apply COM1.
induction H using DNF_ind;simpl.
  apply COM1.
  apply COM1.
  apply COM1.
  apply COM1.
  apply (TRA _ _ ((var x /\p f) \/p (var x /\p g))).
  apply DS3.
  apply aSPLIT.
  apply cGROW_L;auto.
  apply cGROW_R;auto.

apply (TRA _ _ ((f /\p g) /\p f0)).
apply COM1.
induction H1 using DNF_ind;simpl.
  apply COM1.
  apply COM1.
  apply COM1.
  apply COM1.
  apply (TRA _ _ (((f /\p g) /\p f0) \/p ((f /\p g) /\p g0))).
  apply DS3.
  apply aSPLIT.
  apply cGROW_L;auto.
  apply cGROW_R;auto.

apply (TRA _ _ ((f0 /\p f) \/p (f0 /\p g))).
apply DS3.
apply aSPLIT.
induction H1 using DNF_ind.
  apply cGROW_L;apply IHDNF_propForm1;simpl;auto.
  apply cGROW_L;apply IHDNF_propForm1;simpl;auto.
  apply cGROW_L;apply IHDNF_propForm1;simpl;auto.
  apply cGROW_L;apply IHDNF_propForm1;simpl;auto.
  apply (TRA _ _ ((f /\p f0) \/p (f /\p g0))).
  apply (TRA _ _ (f /\p (f0 \/p g0))).
  apply COM1.
  apply DS3.
  apply aSPLIT.
  apply cGROW_L.
  apply (TRA _ _ (f0 /\p f));auto.
  apply COM1.
  apply cGROW_R.
  apply (TRA _ _ (g0 /\p f));auto.
  apply COM1.
induction H1 using DNF_ind.
  apply cGROW_R;apply IHDNF_propForm2;simpl;auto.
  apply cGROW_R;apply IHDNF_propForm2;simpl;auto.
  apply cGROW_R;apply IHDNF_propForm2;simpl;auto.
  apply cGROW_R;apply IHDNF_propForm2;simpl;auto.
  apply (TRA _ _ ((g /\p f0) \/p (g /\p g0))).
  apply (TRA _ _ (g /\p (f0 \/p g0))).
  apply COM1.
  apply DS3.
  apply aSPLIT.
  apply cGROW_L.
  apply (TRA _ _ (f0 /\p g));auto.
  apply COM1.
  apply cGROW_R;auto.
  apply (TRA _ _ (g0 /\p g));auto.
  apply COM1.
Qed.

(*complete for f => toDNF f*)

Lemma complete_propForm_cons_DNF : forall E:_, forall G:relation propVar, forall f:propForm, 
  prv_tree E (stmt G f (toDNF f)).
Proof.
intros.
induction f;simpl in *;auto.
apply REF.
apply REF.
apply REF.

apply aSPLIT;auto.
apply cGROW_L;auto.
apply cGROW_R;auto.

apply (TRA _ _ (toDNF f1 /\p toDNF f2)).
apply cSPLIT.
apply aGROW_L;auto.
apply aGROW_R;auto.
apply distribute_prv_tree;apply DNF_toDNF.
Qed.

(*other from completeness*)

Lemma complete_from_top : forall E:_, forall G:relation propVar, forall f:propForm,
  propForm_cons top f -> prv_tree E (stmt G top f).
Proof.
intros.
induction f;simpl in *.
apply REF.

assert false.
  apply (H empty_environment);auto.
inversion H0.

assert false.
  apply (H empty_environment);auto.
inversion H0.

assert ([[f1 \/p f2]]empty_environment).
  apply H;auto.
simpl in H0;apply orb_true_iff in H0.
destruct H0.
apply cGROW_L;apply IHf1.
intro;intros.
apply empty_true_eqv_top;auto.
apply cGROW_R;apply IHf2.
intro;intros.
apply empty_true_eqv_top;auto.

assert ([[f1 /\p f2]]empty_environment).
  apply H;auto.
simpl in H0;apply andb_true_iff in H0;destruct H0.
apply cSPLIT.
apply IHf1.
intro;intros.
apply empty_true_eqv_top;auto.
apply IHf2.
intro;intros.
apply empty_true_eqv_top;auto.
Qed.

Lemma complete_from_bot : forall E:_, forall G:relation propVar, forall f:propForm,
  prv_tree E (stmt G bot f).
Proof.
intros.
apply (TRA _ _ (f \/p bot)).
apply (TRA _ _ (bot \/p f)).
apply SUP.
apply COM2.
apply BOT.
Qed.


Lemma complete_from_var : forall E:_, forall G:relation propVar, forall f:propForm, forall x:propVar,
  propForm_cons (var x) f -> prv_tree E (stmt G (var x) f).
Proof.
intros;induction f;simpl in *.
apply (TRA _ _ ((var x) /\p top)).
apply TOP.
apply (TRA _ _ (top /\p (var x))).
apply COM1.
apply INF.

assert false.
  apply (H full_environment);simpl;auto.
inversion H0.

rewrite (var_cons_var_eq _ _ H) in *.
apply REF.

assert ([[f1\/p f2]](environment_point x)).
  apply H.
  unfold environment_point;simpl;rewrite<- beq_nat_refl;auto.
simpl in H0.
apply orb_true_iff in H0.
destruct H0.
apply cGROW_L.
apply IHf1.
apply var_cons;auto.
apply cGROW_R.
apply IHf2.
apply var_cons;auto.

assert ([[f1/\p f2]](environment_point x)).
  apply H.
  unfold environment_point;simpl;rewrite<- beq_nat_refl;auto.
simpl in H0.
apply andb_true_iff in H0.
destruct H0.
apply cSPLIT.
apply IHf1.
apply var_cons;auto.
apply IHf2.
apply var_cons;auto.
Qed.

(*other to completenessess*)

Lemma complete_to_bot : forall E:_, forall G:relation propVar, forall f:propForm,
  propForm_cons f bot -> prv_tree E (stmt G f bot).
Proof.
intros.
induction f.
assert (false).
  apply (H full_environment);auto.
inversion H0.

apply REF.

assert (false).
  apply (H full_environment);auto.
inversion H0.

apply aSPLIT.
apply IHf1.
intro;intros.
apply H;apply orb_true_iff;auto.
apply IHf2.
intro;intros.
apply H;apply orb_true_iff;auto.

assert ([[f1/\p f2]]full_environment = false).
  simpl.
  apply not_true_is_false.
  intro.
  specialize (H _ H0).
  inversion H.
simpl in H0.
apply andb_false_iff in H0.
destruct H0.
apply aGROW_L;apply IHf1.
apply not_true_iff_false in H0.
intro;intros;apply (full_false_eqv_bot _ H0);auto.
apply aGROW_R;apply IHf2.
apply not_true_iff_false in H0.
intro;intros;apply (full_false_eqv_bot _ H0);auto.
Qed.

Lemma conj_complete_to_var : forall E:_, forall G:relation propVar, forall f:propForm,
  conj_propForm f -> forall x:propVar, propForm_cons f (var x) -> prv_tree E (stmt G f (var x)).
Proof.
intros.
induction H using conj_ind.
assert (false).
  apply (H0 empty_environment);auto.
inversion H.

apply complete_from_bot;auto.

apply complete_from_var;auto.

destruct (propForm_solution_choice (f /\p g) full_environment).
assert (uses (f/\p g) x).
  apply conj_uses_cons;auto.
  split;auto.
  intro.
  assert false.
    apply (H3 full_environment);auto.
  inversion H4.
simpl in H2;apply andb_true_iff in H2;destruct H2.
simpl in H3;apply orb_true_iff in H3;destruct H3;apply conj_uses_cons in H3;auto.
apply (TRA _ _ f);auto.
apply INF.
intro.
assert false.
  apply (H6 full_environment);auto.
inversion H7.
apply (TRA _ _ g);auto.
apply (TRA _ _ (g /\p f)).
apply COM1.
apply INF.
intro.
assert false.
  apply (H6 full_environment);auto.
inversion H7.

apply (TRA _ _ bot).
apply complete_to_bot;auto.
intro;intros.
apply (full_false_eqv_bot (f /\p g));auto.
apply complete_from_bot;auto.
Qed.

(*proof system is complete for DNF_propForm => propForm*)

Lemma complete_from_conj_propForm : forall E:_, forall G:relation propVar, forall f g:propForm,
  conj_propForm f -> propForm_cons f g -> prv_tree E (stmt G f g).
Proof.
intros.
induction g;simpl in *;auto.
(*g=top*)
apply (TRA _ _ (f /\p top)).
apply TOP.
apply (TRA _ _ (top /\p f)).
apply COM1.
apply INF.

(*g=bot*)
apply (complete_to_bot _ _ _ H0).

(*g=X*)
apply (conj_complete_to_var _ _ f);auto.

(*g=a \/p b*)
destruct (propForm_solution_choice f full_environment).
assert (~ propForm_eqv f bot).
intro.
assert false.
  apply (H2 full_environment);auto.
inversion H3.
assert ([[g1\/p g2]]min_environment f).
  apply H0;apply propForm_min_env;auto.
simpl in H3;apply orb_true_iff in H3;destruct H3.
apply (TRA _ _ g1).
apply IHg1.
apply min_env_cons;auto.
apply SUP.
apply (TRA _ _ g2).
apply IHg2.
apply min_env_cons;auto.
apply (TRA _ _ (g2 \/p g1)).
apply SUP.
apply COM2.
apply (TRA _ _ bot).
apply complete_to_bot.
intro;intros.
apply (full_false_eqv_bot f);auto.
apply complete_from_bot;auto.

(*g=a /\p b*)
destruct (propForm_solution_choice f full_environment).
assert (~ propForm_eqv f bot).
  intro.
  assert false.
    apply (H2 full_environment);auto.
  inversion H3.
assert ([[g1/\p g2]]min_environment f).
  apply H0;apply propForm_min_env;auto.
simpl in H3;apply andb_true_iff in H3;destruct H3.
apply cSPLIT.
apply IHg1.
apply min_env_cons;auto.
apply IHg2.
apply min_env_cons;auto.
apply (TRA _ _ bot).
apply complete_to_bot.
intro;intros.
apply (full_false_eqv_bot f);auto.
apply complete_from_bot;auto.
Qed.

Lemma complete_DNF_cons_propForm : forall E:_, forall G:relation propVar, forall g f:propForm, DNF_propForm f -> 
  propForm_cons f g -> prv_tree E (stmt G f g).
Proof.
intros.
induction H using DNF_ind;simpl in *;auto.

apply complete_from_top;auto.

apply complete_from_bot;auto.

apply complete_from_var;auto.

apply complete_from_conj_propForm;auto.
split;auto.

assert (propForm_cons f g).
  intro;intros;apply H0;apply orb_true_iff;left;auto.
assert (propForm_cons g0 g).
  intro;intro;apply H0;apply orb_true_iff;right;auto.
apply aSPLIT.
apply IHDNF_propForm1;auto.
apply IHDNF_propForm2;auto.
Qed.

(*proof system is complete for logical consequence*)

Lemma complete_cons : forall E:_, forall G:relation propVar, forall f g:propForm,
  propForm_cons f g -> prv_tree E (stmt G f g).
Proof.
intros.
apply (TRA _ _ (toDNF f)).
apply complete_propForm_cons_DNF.
apply complete_DNF_cons_propForm.
apply DNF_toDNF.
intro;intros.
apply H.
apply toDNF_eqv;auto.
Qed.