Require Import Ensembles.

Definition eq_dec (A:Type):=forall x y:A, {x=y} + {x<>y}.

Lemma eq_dec_nat : eq_dec nat.
Proof.
intro;induction x;intros.
destruct y;auto.
induction y;auto.
destruct (IHx y);auto.
Qed.

Definition ens_dec (A:_)(R:Ensemble A):=forall x:_, R x \/ ~R x.

Definition relation (A:Type) := Ensemble (A*A).

Definition id_rel (A:Type):relation A:=
fun (XY:_) => fst XY=snd XY.

Definition remove_var_left (A:Type)(H:eq_dec A)(R:relation A)(a:A):Ensemble (A*A) :=
fun (XY:A*A) => if (H a (fst XY)) then False else R XY.

Definition remove_var_right (A:Type)(H:eq_dec A)(R:relation A)(a:A):Ensemble (A*A) :=
fun (XY:A*A) => if (H a (snd XY)) then False else R XY.