Add LoadPath projectPath.

Require Import relation_definitions.
Require Import propositional_formulas.
Require Import propositional_formulas_semantics.
Require Import consequence_propositional_formula.
Require Import propositional_formula_DNF.
Require Import transitive_closure_minimal_environment.
Require Import relative_consequence.
Require Import relative_consequence_minimal_environment.

Require Import Finite_sets.
Require Import Bool.

Lemma min_env_for_rel_cons : forall (R:_)(l:_)(H:relates_list _ R l)(f:propForm),
  ~propForm_eqv f bot -> conj_propForm f -> forall g:_, [[g]](min_env_for_propForm R l H f) <-> rel_cons R f g.
Proof.
induction g.
split;intros;simpl;auto.
intro;intros;simpl;auto.

split;intros.
inversion H2.
apply H2.
apply min_env_for_propForm_consistent;auto.
apply min_env_for_propForm_self;auto.

induction H1 using conj_ind.
split;intros;auto.
inversion H1.

apply H1;simpl;auto.
apply empty_environment_consistent.

exfalso;apply H0;split;auto.

split;intros.
simpl in H1.
apply (reachable_from_cons _ _ H);auto.
apply (reachable_from_cons _ _ H);auto.
assert (~propForm_eqv f bot).
  intro;apply H0;split;intros.
  apply andb_true_iff in H2;destruct H2;apply H1;auto.
  inversion H2.
assert (~propForm_eqv g bot).
  intro;apply H0;split;intros.
  apply andb_true_iff in H3;destruct H3;apply H2;auto.
  inversion H3.
destruct (IHconj_propForm1 H1).
destruct (IHconj_propForm2 H2).
split;intros.
simpl in *.
intro;intros.
apply andb_true_iff in H9;destruct H9;apply orb_true_iff in H7;destruct H7.
apply H3;auto.
apply H5;auto.
apply H7;auto.
apply min_env_for_propForm_consistent;auto.
apply min_env_for_propForm_self;auto.

split;intros.
simpl in H2;apply orb_true_iff in H2;destruct H2.
intro;intros;apply orb_true_iff;left;apply IHg1;auto.
intro;intros;apply orb_true_iff;right;apply IHg2;auto.
apply H2;auto.
apply min_env_for_propForm_consistent;auto.
apply min_env_for_propForm_self;auto.

split;intros.
intro;intros;simpl in *;apply andb_true_iff in H2;destruct H2;apply andb_true_iff;split.
apply IHg1;auto.
apply IHg2;auto.
simpl;apply andb_true_iff;split.
apply IHg1;intro;intros;specialize (H2 _ H3 H4);apply andb_true_iff in H2;destruct H2;auto.
apply IHg2;intro;intros;specialize (H2 _ H3 H4);apply andb_true_iff in H2;destruct H2;auto.
Qed.

Lemma DNF_rel_cons_propForm_dec : forall R:_, Finite _ R ->
  forall f:_, DNF_propForm f -> forall g:_,
    (rel_cons R f g \/ exists theta:_, consistent_environment theta R /\ [[f]]theta /\ ~[[g]]theta).
Proof.
intros R H f H0;induction H0 using DNF_ind.
intros;destruct (propForm_solution_choice g empty_environment).
left;intro;intros.
apply empty_true_eqv_top;auto.
right;exists empty_environment;split;auto.
apply empty_environment_consistent.

left;intro;intros.
inversion H1.

intros.
destruct (exists_list _ _ H) as [l H1].
destruct (propForm_solution_choice g (reachable_from _ eq_dec_nat _ _ H1 x)).
left;apply (reachable_from_cons _ _ H1 x g);auto.
right;exists (reachable_from nat eq_dec_nat R l H1 x);split.
apply reachable_from_consistent;auto.
split;auto;apply reachable_from_self;auto.

destruct (exists_list _ _ H) as [l H2].
intros;destruct (propForm_solution_choice (f/\p g) full_environment).
destruct (propForm_solution_choice g0 (min_env_for_propForm _ _ H2 (f /\p g))).
left;apply (min_env_for_rel_cons _ _ H2);auto.
intro.
assert ([[bot]]full_environment).
  apply H5;auto.
inversion H6.
simpl;auto.
right;exists (min_env_for_propForm R l H2 (f /\p g)).
split.
apply min_env_for_propForm_consistent.
split;auto.
apply min_env_for_propForm_self.
intro.
assert ([[bot]]full_environment).
  apply H5;auto.
inversion H6.
left;intro;intros.
assert ([[bot]]theta).
  apply (full_false_eqv_bot (f /\p g));auto.
inversion H6.

intros.
destruct (IHDNF_propForm1 g0).
destruct (IHDNF_propForm2 g0).
left;intro;intros.
simpl in H3;apply orb_true_iff in H3;destruct H3.
apply H0;auto.
apply H1;auto.
destruct H1 as [theta H1].
destruct H1.
destruct H2.
right;exists theta.
split;auto.
split;auto.
apply orb_true_iff;auto.
destruct H0 as [theta H0].
destruct H0.
destruct H1.
right;exists theta.
split;auto.
split;auto.
apply orb_true_iff;auto.
Qed.

Lemma rel_cons_dec : forall R:_, Finite _ R ->
  forall f:_, forall g:_,
    (rel_cons R f g \/ exists theta:_, consistent_environment theta R /\ [[f]]theta /\ ~[[g]]theta).
Proof.
intros.
destruct (DNF_rel_cons_propForm_dec _ H _ (DNF_toDNF f) g).
left;intro;intros.
apply H0;auto.
apply (toDNF_eqv f);auto.
destruct H0 as [theta H0].
destruct H0;destruct H1.
right;exists theta;split;auto.
split;auto.
apply (toDNF_eqv f);auto.
Qed.